int LED_R = 12; // LED ROJO conectado en el PIN 12
int LED_IR = 11; // LED IR conectado en el PIN 11
int SENSOR_R = 6; // SENSOR rojo conectado en el PIN analogico 6
int SENSOR_IR = 7; // SENSOR infrarrojo conectado en el PIN analogico 7
float SENSOR_VALOR_R = 0; // Lectura del sensor para luz roja encendida
float SENSOR_VALOR_IR = 0; // Lectura del sensor para luz infrarroja encendida
int INTERRUPTOR_R = 10; // Controla el interruptor rojo por el PIN 10
int INTERRUPTOR_IR = 9; // Controla el interruptor infrarrojo por el PIN 9
int CICLOS = 0; // Contador de ciclos de encendido LEDs emisores
int NUM_MUESTRAS = 0; // Contador de muestras
float MEDIA = 0; // Media de la señal
float SENSOR_VALOR_R_ANT = 0; // Valor anterior de la señal roja
float SENSOR_VALOR_IR_ANT = 0; // Valor anterior de la señal infrarroja
float TIEMPO_INI_PULSO = 0; // Tiempo en que se produce un cruce
float TIEMPO_INI_PULSO_ANT = 0; // Tiempo en que se produjo el cruce anterior
float NUM_CRUCES = 0; // Contador de cruces
float MEDIA_PERIODOS = 0; // Media de los períodos medidos
float PERIODO = 0; // Valor de un período
float PULSO_CARD = 0; // Pulso cardíaco
float dA_R = 0; // Absorción delta roja
float dA_IR = 0; // Absorción delta infrarroja
float RATIO = 0; // Ratio de absorción
float RATIO_PROV = 0; // Ratio de absorción provisional
float MEDIA_RATIO = 0; // Media de ratios calculados
float SAO2 = 0; // Porcentaje de saturación de oxígeno
void setup() {
pinMode (LED_R, OUTPUT); // Configuración del PIN LED_R como salida
pinMode (LED_IR, OUTPUT); // Configuración del PIN LED_IR como salida
pinMode (SENSOR_R, INPUT); // Configuración del PIN SENSOR rojo como entrada
pinMode (SENSOR_IR, INPUT); // Configuración del PIN SENSOR infrarrojo como entrada
pinMode (INTERRUPTOR_R, OUTPUT); // Configuración del PIN INTERRUPTOR_R como salida
pinMode (INTERRUPTOR_IR, OUTPUT); // Configuración del PIN INTERRUPTOR_IR como salida
analogReference (DEFAULT); // Configuración de la tensión de referencia por defecto (5 V)
Serial.begin (9600); // Configuración para la transmisión de los datos por el puerto serie
}
void loop() {
// Ciclos de encendido y apagado alterno de los LEDs emisores
// Cada ciclo tiene una duración total de 2 milisegundos (100 ciclos = 200 milisegundos)
for (CICLOS = 0; CICLOS <= 100; CICLOS++) {
digitalWrite (LED_R, HIGH); // Encendido del LED rojo
delayMicroseconds (10); // Espera para encendido completo del LED
digitalWrite (INTERRUPTOR_R, HIGH); // Cierre del interruptor rojo
delayMicroseconds (960); // Espera para estabilización de señal
SENSOR_VALOR_R = analogRead (SENSOR_R); // Lectura del pin analógico del sensor rojo
digitalWrite (INTERRUPTOR_R, LOW); // Apertura del interruptor rojo
delayMicroseconds (10); // Espera para apertura completa del interruptor
digitalWrite (LED_R, LOW); // Apagado del LED rojo
delayMicroseconds (20);
digitalWrite (LED_IR, HIGH); // Encendido del LED infrarrojo
delayMicroseconds (10); // Espera para encendido completo del LED
digitalWrite (INTERRUPTOR_IR, HIGH); // Cierre del interruptor infrarrojo
delayMicroseconds (960); // Espera para estabilización de señal
SENSOR_VALOR_IR = analogRead (SENSOR_IR); // Lectura del pin analógico del sensor infrarrojo
digitalWrite (INTERRUPTOR_IR, LOW); // Apertura del interruptor infrarrojo
delayMicroseconds (10); // Espera para apertura completa del interruptor
digitalWrite (LED_IR, LOW); // Apagado del LED infrarrojo
delayMicroseconds (20);
}
CICLOS = 0; // Se reinicia el contador de ciclos
NUM_MUESTRAS = NUM_MUESTRAS+1; // Se coge una muestra cada 200 milisegundos
// Los valores del pulso y de la saturación de oxígeno se calculan y se muestran cada 7 segundos
if (NUM_MUESTRAS <= 35) {
MEDIA = (MEDIA*(NUM_MUESTRAS-1) + SENSOR_VALOR_R)/NUM_MUESTRAS;
// Durante los primeros 3 segundos sólo se ha calculado la media de la señal roja
// Si han pasado los 3 primeros segundos, empezamos a buscar los cruces por la media y a calcular el ratio
if (NUM_MUESTRAS > 15) {
if (SENSOR_VALOR_R_ANT > MEDIA && SENSOR_VALOR_R < MEDIA) { // Se detecta un cruce
TIEMPO_INI_PULSO = millis(); // Se captura el tiempo en el que se produce el cruce
if (NUM_CRUCES == 0) { // Si es el primer cruce encontrado
TIEMPO_INI_PULSO_ANT = TIEMPO_INI_PULSO;
}
if (NUM_CRUCES >= 1) { // A partir del segundo cruce encontrado
// Se calcula el período entre este cruce y el anterior
PERIODO = TIEMPO_INI_PULSO - TIEMPO_INI_PULSO_ANT;
TIEMPO_INI_PULSO_ANT = TIEMPO_INI_PULSO;
// Se calcula una media entre los períodos encontrados hasta el momento
MEDIA_PERIODOS = (MEDIA_PERIODOS*(NUM_CRUCES-1) + PERIODO)/NUM_CRUCES;
}
NUM_CRUCES = NUM_CRUCES+1;
}
// Utilizamos el método de absorción delta para el cálculo del ratio
dA_R = (SENSOR_VALOR_R-SENSOR_VALOR_R_ANT)*2/(SENSOR_VALOR_R+SENSOR_VALOR_R_ANT);
dA_IR = (SENSOR_VALOR_IR-SENSOR_VALOR_IR_ANT)*2/(SENSOR_VALOR_IR+SENSOR_VALOR_IR_ANT);
RATIO_PROV = dA_IR/dA_R;
// Si el ratio provisional sale infinito, no se tiene en cuenta y se usa el ratio anterior para la media
if (RATIO_PROV != INFINITY) {
RATIO = RATIO_PROV;
}
// Se calcula una media entre los ratios calculados hasta el momento
MEDIA_RATIO = (MEDIA_RATIO*(NUM_MUESTRAS-16)+RATIO)/(NUM_MUESTRAS-15);
SENSOR_VALOR_R_ANT = SENSOR_VALOR_R;
SENSOR_VALOR_IR_ANT = SENSOR_VALOR_IR;
}
}
else {
//Calculamos y mostramos por pantalla los valores de pulso y saturación de oxígeno
PULSO_CARD = 60000/MEDIA_PERIODOS;
SAO2 = 115-(30*MEDIA_RATIO);
Serial.print ("Pulso cardiaco = ");
Serial.println (PULSO_CARD);
Serial.print ("Saturacion de oxigeno = ");
Serial.println (SAO2);
Serial.println ();
NUM_MUESTRAS = 0;
MEDIA = 0;
SENSOR_VALOR_R_ANT = 0;
SENSOR_VALOR_IR_ANT = 0;
TIEMPO_INI_PULSO = 0;
TIEMPO_INI_PULSO_ANT = 0;
NUM_CRUCES = 0;
MEDIA_PERIODOS = 0;
PERIODO = 0;
MEDIA_RATIO = 0;
RATIO = 0;
RATIO_PROV = 0;
}
}
